Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
EggBinMaker Class Referenceabstract

This is a handy class for collecting related nodes together. More...

`#include "eggBinMaker.h"`

Inheritance diagram for EggBinMaker:

## Public Member Functions
virtual bool | collapse_group (const EggGroup *group, int bin_number)
| May be overridden in derived classes to specify whether a particular group node, apparently redundant, may be safely collapsed out.
virtual TypeHandle | force_init_type ()
virtual std::string | get_bin_name (int bin_number, const EggNode *child)
| May be overridden in derived classes to define a name for each new bin, based on its bin number, and a sample child.
virtual int | get_bin_number (const EggNode *node)=0
virtual TypeHandle | get_type () const
int | make_bins (EggGroupNode *root_group)
| The main entry point to EggBinMaker.
virtual void | prepare_node (EggNode *node)
| May be overridden in derived classes to perform some setup work as each node is encountered.
virtual | PT (EggBin) make_bin(int bin_number
virtual bool | sorts_less (int bin_number, const EggNode *a, const EggNode *b)
| May be overridden in derived classes to create additional bins within a particular bin number, based on some arbitrary property of nodes.
Public Member Functions inherited from EggObject
| EggObject (const EggObject &copy)
virtual EggTransform * | as_transform ()
| Returns this object cross-cast to an EggTransform pointer, if it inherits from EggTransform, or NULL if it does not.
void | clear_user_data ()
| Removes *all* user data pointers from the node.
void | clear_user_data (TypeHandle type)
| Removes the user data pointer of the indicated type.
EggUserData * | get_user_data () const
| Returns the user data pointer most recently stored on this object, or NULL if nothing was previously stored.
EggUserData * | get_user_data (TypeHandle type) const
| Returns the user data pointer of the indicated type, if it exists, or NULL if it does not.
bool | has_user_data () const
| Returns true if a generic user data pointer has recently been set and not yet cleared, false otherwise.
bool | has_user_data (TypeHandle type) const
| Returns true if the user data pointer of the indicated type has been set, false otherwise.
EggObject & | operator= (const EggObject &copy)
void | set_user_data (EggUserData *user_data)
| Sets the user data associated with this object.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
virtual const EggNode * | child
virtual const EggNode EggGroup * | collapse_from
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

This is a handy class for collecting related nodes together.

It is an abstract class; to use it you must subclass off of it. See the somewhat lengthy comment above.

Definition at line 161 of file eggBinMaker.h.

## Constructor & Destructor Documentation

## ◆ EggBinMaker()

EggBinMaker::EggBinMaker | ( |  | ) |

Definition at line 49 of file eggBinMaker.cxx.

## ◆ ~EggBinMaker()

EggBinMaker::~EggBinMaker | ( |  | ) |

Definition at line 56 of file eggBinMaker.cxx.

## Member Function Documentation

## ◆ collapse_group()

bool EggBinMaker::collapse_group | ( | const EggGroup * | group,
|  | int | bin_number )
| virtual

May be overridden in derived classes to specify whether a particular group node, apparently redundant, may be safely collapsed out.

Definition at line 106 of file eggBinMaker.cxx.

## ◆ force_init_type()

virtual TypeHandle EggBinMaker::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from EggObject.

Definition at line 219 of file eggBinMaker.h.

## ◆ get_bin_name()

std::string EggBinMaker::get_bin_name | ( | int | bin_number,
|  | const EggNode * | child )
| virtual

May be overridden in derived classes to define a name for each new bin, based on its bin number, and a sample child.

Reimplemented in EggBinner.

Definition at line 115 of file eggBinMaker.cxx.

## ◆ get_class_type()

static TypeHandle EggBinMaker::get_class_type | ( |  | ) |
| inline static

Definition at line 208 of file eggBinMaker.h.

## ◆ get_type()

virtual TypeHandle EggBinMaker::get_type | ( |  | ) | const
| inline virtual

Reimplemented from EggObject.

Definition at line 216 of file eggBinMaker.h.

## ◆ init_type()

static void EggBinMaker::init_type | ( |  | ) |
| inline static

Definition at line 211 of file eggBinMaker.h.

## ◆ make_bins()

int EggBinMaker::make_bins | ( | EggGroupNode * | root_group | ) |

The main entry point to EggBinMaker.

Walks the egg scene graph beginning at the indicated root node, and moves all binnable nodes into EggBin objects. Returns the number of EggBins created.

Definition at line 66 of file eggBinMaker.cxx.

Referenced by XFileMaker::add_tree().

## ◆ prepare_node()

void EggBinMaker::prepare_node | ( | EggNode * | node | ) |
| virtual

May be overridden in derived classes to perform some setup work as each node is encountered.

This will be called once for each node in the egg hierarchy.

Reimplemented in EggBinner.

Definition at line 86 of file eggBinMaker.cxx.

## ◆ sorts_less()

bool EggBinMaker::sorts_less | ( | int | bin_number,
|  | const EggNode * | a,
|  | const EggNode * | b )
| virtual

May be overridden in derived classes to create additional bins within a particular bin number, based on some arbitrary property of nodes.

This function establishes an arbitrary but fixed ordering between nodes; if two nodes do not sort to the same position, different bins are created for each one (with the same bin number on each bin).

Reimplemented in EggBinner, and EggPolysetMaker.

Definition at line 97 of file eggBinMaker.cxx.

## Member Data Documentation

## ◆ child

virtual const EggNode* EggBinMaker::child

Definition at line 184 of file eggBinMaker.h.

## ◆ collapse_from

virtual const EggNode EggGroup* EggBinMaker::collapse_from

Definition at line 184 of file eggBinMaker.h.

The documentation for this class was generated from the following files:

- panda/src/egg/eggBinMaker.h
- panda/src/egg/eggBinMaker.cxx